Differences between revisions 5 and 13 (spanning 8 versions)
Revision 5 as of 2011-08-12 12:56:10
Size: 1844
Editor: GreyCat
Comment: since exercise 2 broke in bash 4.1, we need to adjust the text a bit...
Revision 13 as of 2016-04-25 14:49:27
Size: 713
Editor: OrvilleMcq
Comment:
Deletions are marked like this. Additions are marked like this.
Line 1: Line 1:
<<Anchor(faq105)>>
== Why doesn't set -e (set -o errexit) do what I expected? ==
`set -e` was an attempt to add "automatic error detection" to the shell. Its ''goal'' was to cause the shell to abort any time an error occurred, so you don't have to put `|| exit 1` after each important command.

That goal is non-trivial, because many commands are ''supposed'' to return non-zero. For example,

{{{
  if [ -d /foo ]; then
    ...
  else
    ...
  fi
}}}

Clearly we don't want to abort when `[ -d /foo ]` returns non-zero (because the directory does not exist) -- our script wants to handle that in the `else` part. So the implementors decided to make a bunch of special rules, like "commands that are part of an `if` test are immune", or "commands in a pipeline, other than the last one, are immune".

These rules are extremely convoluted, and they still fail to catch even some remarkably simple cases. Even worse, the rules ''change'' from one Bash version to another, as Bash attempts to track the extremely slippery POSIX definition of this "feature". When a SubShell is involved, it gets worse still -- the behavior changes depending on whether Bash is invoked in POSIX mode. [[http://fvue.nl/wiki/Bash:_Error_handling|Another wiki]] has a page that covers this in more detail. Be sure to check the caveats.

''Exercise for the reader: why doesn't this example print anything?''

{{{#!highlight bash
#!/bin/bash
set -e
i=0
let i++
echo "i is $i"
}}}

''Exercise 2: why does ''this'' one sometimes appear to work? In which versions of bash does it work, and in which versions does it fail?''

{{{#!highlight bash
#!/bin/bash
set -e
i=0
((i++))
echo "i is $i"
}}}

([[/Answers|Answers]])

GreyCat's personal recommendation is simple: don't use `set -e`. Add your own error checking instead.
Melvin Hartung is what my wife enjoys to call me although it is not the title on my birth certification. Tennessee is her birth place. I work as a inventory control and order filler but I've always wanted my own business. The favorite pastime for him and his children is to fence and he's been doing it for quite a whilst. Her spouse and her preserve a web site. You may want to check it out: http://www.netgestalter.de/blog/blogging/wieder-zurueck-und-das-ende-der-blogparade.html<br><br><<BR>>
<<BR>>
 http://i1038.photobucket.com/albums/a462/Harukomel/HTML/4.jpg Visit my blog post ... [[http://www.netgestalter.de/blog/blogging/wieder-zurueck-und-das-ende-der-blogparade.html|social media consulting]]<br>

Melvin Hartung is what my wife enjoys to call me although it is not the title on my birth certification. Tennessee is her birth place. I work as a inventory control and order filler but I've always wanted my own business. The favorite pastime for him and his children is to fence and he's been doing it for quite a whilst. Her spouse and her preserve a web site. You may want to check it out: http://www.netgestalter.de/blog/blogging/wieder-zurueck-und-das-ende-der-blogparade.html<br><br><<BR>>

BashFAQ/105 (last edited 2021-03-11 06:07:25 by dsl-66-36-156-249)